<template>
  <a-card :bordered="false">
    <div class="table-page-search-wrapper" @keyup.enter="handleEnter">
      <a-form layout="inline">
        <a-row :gutter="48">
          <a-col :md="8" :sm="24">
            <a-form-item label="关键字">
              <a-input v-model="queryParam.keyword" placeholder="请输入设备编号/设备名称/卡片编号"/>
            </a-form-item>
          </a-col>

          <a-col :md="6" :sm="24">
            <a-form-item label="设备型号">
              <a-select
                v-model="queryParam.modelId"
                placeholder="请选择">
                <a-select-option
                  v-for="(item,index) in modelList"
                  :key="index"
                  :label="item.nameModel"
                  :value="item.id">{{ item.nameModel }}
                </a-select-option>
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :md="8 || 24" :sm="24">
            <span class="table-page-search-submitButtons">
              <a-button type="primary" @click="$refs.table.refresh(true)">查询</a-button>
              <a-button style="margin-left: 8px" @click="resetSearchForm">重置</a-button>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>

    <div class="table-operator">
      <a-button v-if="$auth('sb-inspection-fills-add')" type="primary" icon="plus" @click="$refs.baseFormList.base(null,DictCache.VALUE.FILL_INFO_USE_TYPE.FILL_INFO_USE_TYPE_XUN_JIAN)">新增</a-button>
      <a-button style="margin-left: 8px" v-if="$auth('sb-inspection-fills-export')" type="primary" icon="download" @click="doExport">导出</a-button>
      <a-dropdown v-action:edit v-if="selectedRowKeys.length > 0 && $auth('sb-inspection-fills-del')">
        <a-menu slot="overlay">
          <a-popconfirm title="是否要删除所选数据？" @confirm="batchDelete()">
            <a-menu-item key="1"><a-icon type="delete" /><a>删除</a></a-menu-item>
          </a-popconfirm>
        </a-menu>
        <a-button style="margin-left: 8px">
          批量操作 <a-icon type="down" />
        </a-button>
      </a-dropdown>
    </div>

    <s-table
      ref="table"
      size="default"
      rowKey="id"
      :bordered="this.MyGlobalConstant.BORDERED"
      :columns="columns"
      :data="loadData"
      :alert="options.alert"
      :rowSelection="options.rowSelection"
      showPagination="auto"
    >
      <span slot="action" slot-scope="record">
        <template>
          <a @click="handleView(record)">查看</a>
          <operation-button
            v-if="$auth('sb-inspection-fills-edit')"
            @click="handleEdit(record)"
          >修改</operation-button>
          <operation-button
            v-if="$auth('sb-inspection-fills-del')"
            :type="2"
            title="是否要删除该条数据？"
            @confirm="batchDelete(record.id)">删除</operation-button>
        </template>
      </span>
    </s-table>
    <base-form :use-type="DictCache.VALUE.FILL_INFO_USE_TYPE.FILL_INFO_USE_TYPE_XUN_JIAN" ref="baseModal" @ok="handleOk"/>
    <base-form-list :fill-filter="filter" ref="baseFormList" @ok="handleOk"/>
    <detail ref="detailModal"/>
  </a-card>
</template>

<script>
import { STable, Ellipsis } from '@/components'
import BaseForm from '@/views/sb/run-fill/modules/BaseForm'
import Detail from '@/views/sb/run-fill/modules/Detail'
import BaseFormList from '@/views/sb/run-fill/modules/BaseFormList'
import { queryFillInfo } from '@/api/fill/info'
import { getSbInspectionFillPage, deleteSbInspectionFills, fetchSbInspectionFill, exportSbInspectionFill } from '@/api/sb/inspection-fill'
import { querySbInfo } from '@/api/sb/model'
import { queryFillProjectQuantityDeptProject } from '@/api/fill/project-quantity'

export default {
  name: 'SbInspectionFillList',
  components: {
    STable,
    Ellipsis,
    BaseForm,
    BaseFormList,
    Detail
  },
  props: {
    filter: {
      type: Number,
      default: 1
    }
  },
  data () {
    return {
      // 查询参数
      queryParam: {
      },
      // 表头
      columns: [],
      selectOptionMap: {},
      radioGroupMap: {},
      modelList: [],
      projectQuantityList: [],
      // 下拉框map
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        parameter = {
          ...parameter,
          ...this.queryParam,
          filter: this.filter
        }
        return getSbInspectionFillPage(parameter)
          .then(res => {
            return res.data
          })
      },
      selectedRowKeys: [],
      selectedRows: [],

      options: {
        alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
        rowSelection: {
          selectedRowKeys: this.selectedRowKeys,
          onChange: this.onSelectChange
        }
      },
      optionAlertShow: false
    }
  },
  created () {
    // 下拉框map
    this.initData()
    this.tableOption()
    this.getMyColumn()
  },
  methods: {
    initData () {
      querySbInfo({}).then(res => {
        this.modelList = res.data
      })
      queryFillProjectQuantityDeptProject().then(res => {
        this.projectQuantityList = res.data
      })
    },
    tableOption () {
      if (!this.optionAlertShow) {
        this.options = {
          alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
          rowSelection: {
            selectedRowKeys: this.selectedRowKeys,
            onChange: this.onSelectChange,
            getCheckboxProps: record => ({
              props: {
                disabled: false,
                name: record.id
              }
            })
          }
        }
        this.optionAlertShow = true
      } else {
        this.options = {
          alert: false,
          rowSelection: null
        }
        this.optionAlertShow = false
      }
    },
    getMyColumn () {
      let columns = []
      columns = columns.concat([
        {
          title: '序号',
          dataIndex: 'index',
          customRender: (text, record, index) => {
            return `${(this.$refs.table.localPagination.current - 1) * this.$refs.table.localPagination.pageSize + index + 1}`
          }
        },
        {
          title: '设备编号',
          dataIndex: 'sbNo'
        },
        {
          title: '设备名称',
          dataIndex: 'sbName'
        },
        {
          title: '日期',
          dataIndex: 'fillDate'
        },
        {
          title: '创建时间',
          dataIndex: 'createdTime'
        },
        {
          title: '创建人',
          dataIndex: 'createdUserName'
        },
        {
          title: '创建日期',
          dataIndex: 'createdTime'
        },
        {
          title: '操作',
          key: 'action',
          width: '200px',
          align: 'center',
          scopedSlots: { customRender: 'action' }
        }])

      /* queryFillInfo({ useType: this.DictCache.VALUE.FILL_INFO_USE_TYPE.FILL_INFO_USE_TYPE_XUN_JIAN }).then(res => {
        const fillInfoList = res.data
        let myColumns = []
        myColumns = myColumns.concat([
          {
            title: '序号',
            dataIndex: 'index',
            customRender: (text, record, index) => {
              return `${(this.$refs.table.localPagination.current - 1) * this.$refs.table.localPagination.pageSize + index + 1}`
            }
          },
          {
            title: '设备编号',
            dataIndex: 'sbNo'
          },
          {
            title: '设备名称',
            dataIndex: 'sbName'
          }])
        fillInfoList.forEach(fillInfo => {
          myColumns = myColumns.concat([{
            title: fillInfo.name,
            dataIndex: fillInfo.id,
            customRender: (text, record, index) => {
              const fillInfoValueList = record.fillInfoList
              if (fillInfoValueList == null || fillInfoValueList.length === 0) {
                return ''
              }
              for (const fillInfoValue of fillInfoValueList) {
                if (fillInfoValue.infoId === fillInfo.id) {
                  if (fillInfoValue.type === this.DictCache.VALUE.FILL_INFO_TYPE.FILL_INFO_TYPE_INT) {
                    return fillInfoValue.resultValue
                  } else if (fillInfoValue.type === this.DictCache.VALUE.FILL_INFO_TYPE.FILL_INFO_TYPE_DECIMAL) {
                    return fillInfoValue.resultNumber
                  } else if (fillInfoValue.type === this.DictCache.VALUE.FILL_INFO_TYPE.FILL_INFO_TYPE_FAN_WEI) {
                    let result = fillInfoValue.resultStart + '~' + fillInfoValue.resultEnd
                    if (fillInfoValue.codeValue === this.DictCache.VALUE.FILL_INFO_CODE_VALUE.FILL_INFO_CODE_VALUE_SJS) {
                      result += '小时'
                    } else if (fillInfoValue.codeValue === this.DictCache.VALUE.FILL_INFO_CODE_VALUE.FILL_INFO_CODE_VALUE_GLS) {
                      result += 'KM'
                    }
                    return result
                  } else if (fillInfoValue.type === this.DictCache.VALUE.FILL_INFO_TYPE.FILL_INFO_TYPE_STRING) {
                    return fillInfoValue.resultDesc
                  } else if (fillInfoValue.type === this.DictCache.VALUE.FILL_INFO_TYPE.FILL_INFO_TYPE_XIA_LA) {
                    return this.getSelectOptions(fillInfoValue)[fillInfoValue.resultValue]
                  } else if (fillInfoValue.type === this.DictCache.VALUE.FILL_INFO_TYPE.FILL_INFO_TYPE_DAN_XUAN) {
                    return this.getSelectOptions(fillInfoValue)[fillInfoValue.resultValue]
                  } else {
                    return ''
                  }
                }
              }
              return ''
            }
          }])
        })
        myColumns = myColumns.concat([ {
          title: '创建日期',
          dataIndex: 'createdTime'
        },
        {
          title: '操作',
          key: 'action',
          width: '200px',
          align: 'center',
          scopedSlots: { customRender: 'action' }
        }])
        this.columns = myColumns
      }) */
      this.columns = columns
    },
    getSelectOptions (fillInfo) {
      if (this.BaseTool.Object.isBlank(this.selectOptionMap[fillInfo.dictType])) {
        this.selectOptionMap[fillInfo.dictType] = this.DictCache.getLabelByValueMapByType(fillInfo.dictType)
      }
      return this.selectOptionMap[fillInfo.dictType]
    },
    batchDelete (id) {
      let ids = []
      if (this.BaseTool.String.isBlank(id)) {
        const length = this.selectedRows.length
        if (length === 0) {
          this.$message.info('请选择要删除的记录')
          return
        }
        ids = this.selectedRows.map(item => item.id)
      } else {
        ids = [id]
      }
      deleteSbInspectionFills(ids).then(res => {
        this.$message.info('删除成功')
        this.handleOk()
        this.$refs.table.clearSelected()
      })
    },
    handleEdit (record) {
      fetchSbInspectionFill({ id: record.id }).then(res => {
        const modal = this.$refs.baseModal
        modal.base(res.data)
      })
    },
    handleView (record) {
      fetchSbInspectionFill({ id: record.id }).then(res => {
        const modal = this.$refs.detailModal
        modal.base(res.data, this.projectQuantityList)
      })
    },
    handleOk () {
      this.$refs.table.refresh()
    },
    onSelectChange (selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    resetSearchForm () {
      this.queryParam = {
      }
      this.$refs.table.refresh(true)
    },
    doExport () {
      const parameter = {
        ...this.queryParam
      }
      exportSbInspectionFill(parameter).then(file => {
        this.BaseTool.UPLOAD.downLoadExportExcel(file)
      })
    },
    handleEnter () {
      this.$refs.table.refresh(true)
    }
  }
}
</script>
